import shapes3d.utils.*;
import shapes3d.animation.*;
import shapes3d.*;

Cone cone;
float angleX, angleY, angleZ;

public void setup() {
  size(400, 400, P3D);
  cone = new Cone(this, 40);
  cone.setSize(140, 140, 100);
  cone.moveTo(new PVector(0, 10, 0));
  cone.setTexture("stars03.jpg", S3D.CONE);
  cone.drawMode(S3D.TEXTURE, S3D.CONE);
  cone.fill(color(96, 10, 150), S3D.BASE);
  cone.stroke(color(180, 0, 0), S3D.BASE);
  cone.strokeWeight(0.8f, S3D.BASE);
  cone.drawMode(S3D.SOLID, S3D.BASE);
}

public void draw() {
  background(240, 220, 240);
  // 3D draw first
  pushMatrix();
  camera(0, 0, 300, 0, 0, 0, 0, 1, 0);
  angleX = PI/12;
  angleY = 0;
  angleZ = PI/6;
  rotateX(angleX);
  rotateY(angleY);
  rotateZ(angleZ);
  cone.draw();
  popMatrix();
}
