import shapes3d.utils.*;
import shapes3d.animation.*;
import shapes3d.*;

Box box;
float angleX, angleY, angleZ;

public void setup() {
  size(400, 400, P3D);
  box = new Box(this);
  String[] faces = new String[] {
    "dice1.png", "dice2.png", "dice3.png", 
    "dice4.png", "dice5.png", "dice6.png"
  };
  box.setTextures(faces);
  box.fill(color(255));
  box.stroke(color(190));
  box.strokeWeight(1.2f);
  box.setSize(100, 100, 100);
  //    box.rotateTo(radians(45), radians(45), radians(45));
  box.drawMode(S3D.TEXTURE | S3D.WIRE);
  box.shapeOrientation(null, new PVector(20, 20, 20));
}

public void draw() {
  background(240, 220, 240);
  pushMatrix();
  camera(0, 0, 300, 0, 0, 0, 0, 1, 0);
  angleX += radians(0.913f);
  angleY += radians(0.799f);
  angleZ += radians(1.213f);
  rotateX(angleX);
  rotateY(angleY);
  rotateZ(angleZ);
  box.draw();
  popMatrix();
}
